#  V260.defn.tcl

proc {Add_CAEN V260_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server

   for {set i 0} {$i < 16} {incr i} {
      define-vme-register $name xVME Counter$i        "-a$A24addrbase -w24 -o[expr 0x10+($i*4)] -pro -d32 -l0 -b0 -zd"
   }
 
   define-vme-register $name xVME Clear               "-a$A24addrbase -w24 -o0x50 -prw -d16 -l0 -b0 -zx -i0"
   define-vme-register $name xVME SetVeto             "-a$A24addrbase -w24 -o0x52 -prw -d16 -l0 -b0 -zx -i0"
   define-vme-register $name xVME RstVeto             "-a$A24addrbase -w24 -o0x54 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Config              "-a$A24addrbase -w24 -o0x58 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Incr                "-a$A24addrbase -w24 -o0x56 -prw -d16 -l0 -b0 -zx"

   define-vme-register $name xVME ModID#1              "-a$A24addrbase -w24 -o0xfe -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#2              "-a$A24addrbase -w24 -o0xfc -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#3              "-a$A24addrbase -w24 -o0xfa -pro -d16 -l0 -b0 -zx"
}


proc {CAEN V260_DAQ-reset} {args} {
#   V260
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.ModID#1] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {CAEN V260_DAQ-flush} {args} {
#   V260
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V260_DAQ-go} {args} {
#   V260
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.Clear 0
    write-vme-register $module.RstVeto 0
}

proc {CAEN V260_DAQ-halt} {args} {
#   V260
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.SetVeto 0
}

proc {CAEN V260_DAQ-setup} {args} {
#   V260
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    initialise-vme-registers $module.*
}

#   for parameter save/restore
set {CAEN V260_registersavepatterns} {}


